// Project 34 - DC Motor Control with PWM and MOSFET

#include <avr/io.h>
#include <util/delay.h>
#define wait 10

void initPWM(void) 
{
    // Timer 1A and 1B
    TCCR1A |= (1 << WGM10);  // Fast PWM mode
    TCCR1B |= (1 << WGM12);  // Fast PWM mode
    TCCR1B |= (1 << CS11);   
}

void motorOff(void)
{
    TCCR1A &= ~(1 << COM1A1);  // disconnect PWM from PB1
    PORTB &= ~(1 << PORTB1);   // set PB1 off
}

void motorOn(void)
{
    TCCR1A &= ~(1 << COM1A1);  // disconnect PWM from PB1
    PORTB |= (1 << PORTB1);    // set PB1 on
}

void motorPWM(uint8_t duty)
{
    TCCR1A |= (1 << COM1A1);   // connect PWM to OCR1A - PB1 
    OCR1A = duty;
}

void setup()
{
}

int main(void)
{
    DDRB |= (1 << PORTB1); // set PORTB pin 1 as output
    initPWM();
    uint8_t a;

    while(1)
    { 
        motorOff();					// motor off
        _delay_ms(3000);
		
        for (a = 1; a <255; a++)	// slowly increase motor speed
        {
            motorPWM(a);
            _delay_ms(wait);
        }
	
        motorOn();					// motor full on
        _delay_ms(1000);		
		
        for (a = 254; a > 0; --a)	// slowly decrease motor speed
        {
            motorPWM(a);
            _delay_ms(wait);
        }
    }	
}